<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

$admin_menu[] = array(0, "База данных", "?mod=database", "images/mini_database.gif", "database");
//$admin_menu[] = array(1, "Резервная копия", "?mod=database&action=backup");
//$admin_menu[] = array(1, "Ротация данных", "?mod=database&action=rotation");
//$admin_menu[] = array(1, "Закрытие года", "?mod=database&action=endyear", "images/mini_endyear.gif");
$admin_menu[] = array(1, "Сброс статистики", "?mod=database&action=stat_clear");
$admin_menu[] = array(1, "Очистка БД", "?mod=database&action=clear_db");

$modules_list[] = array("database", "Модуль управления базой данных", "0.1", "Zuskin Egor", "egor@elvis-group.ru", "", "");

function database_init($action, $oid)
{
	global $netams;
	switch($action)
	{
		case "backup":
			if (!isset($_GET['save']) && @$_GET['save'] <> "yes")
			{
				head_html("Создание резервной копии");
				print "<font class=title>Создание резервной копии</font><BR><BR>";
				print "<form id=bform name=bform action='?mod=database&action=backup&save=yes' method=post>";
				print "<input type=\"radio\" name=\"type\" value=\"0\" checked>&nbsp;За весь период<br>";
				print "<input type=\"radio\" name=\"type\" value=\"1\">&nbsp;За текущий год<BR>";
				print "<input type=\"radio\" name=\"type\" value=\"2\">&nbsp;За указанный период<BR>";
				print "Период с ".date_input("bform", "bdate",date("d.m.Y",mktime(0,0,0,1,1,date("Y"))))." по ".date_input("bform", "edate", date("d.m.Y",mktime(0,0,0,12,31,date("Y"))))."<BR><BR>";
				print "<input type=\"submit\" value=\"Создать\">";
				print "</form>";
				foot_html();
			} else {
				$type = intval(@$_POST['type']);
				$bdate = isset($_POST['bdate']) ? $_POST['bdate'] : 0;
				$bdate = isset($_POST['edate']) ? $_POST['edate'] : 0;
				switch($type)
				{
					case 0:
						$file_path = cfg("backup_dir")."/backup_total_".time().".sql";
						$bdate = 0;
						$edate = 0;
					break;
					case 1:
						$file_path = cfg("backup_dir")."/backup_year_".date("Y")."_".time().".sql";
						$bdate = mktime(0,0,0,1,1,date("Y"));
						$edate = mktime(0,0,0,12,31,date("Y"));
					break;
					case 2:
						if (!isset($_POST['bdate']) || !isset($_POST['edate'])) die("invalid period");
						$file_path = cfg("backup_dir")."/backup_period_".$_POST['bdate']."-".$_POST['edate']."_".time().".sql";
						$tmp = explode(".",$_POST['bdate']);
						$bdate = mktime(0,0,0,$tmp[1],$tmp[0],$tmp[2]);
						$tmp = explode(".",$_POST['edate']);
						$edate = mktime(0,0,0,$tmp[1],$tmp[0],$tmp[2]);
					break;
				}
				head_html("Создание резервной копии");
				total_backup($file_path, $bdate, $edate);
				foot_html();
			}
		break;

		case "stat_clear":
			if (!isset($_GET['save']) && @$_GET['save'] <> "yes")
			{
				head_html("Сброс статистики");
				note("<font color=red>Перед сбросом статистики остановите сервис netams в пративном случае статистика не сбросится</font>.<br><br>".del_btn("Сброс статистики","?mod=database&action=stat_clear&save=yes","Вы уверенны что хотите сбросить статистику за весь период?"),"Сброс статистики");
				foot_html();
			}
			else
			{
				$netams->config_save();
				$netams->reload();
                db_query("TRUNCATE `raw`");
                db_query("TRUNCATE `summary`");
                header("Location: ?mod=database");
			}
		break;

		case "clear_db";
			if (!isset($_GET['save']) && @$_GET['save'] <> "yes")
			{
				$table = new Table();
                $table->title("Таблица|Записей|Действие");
				$total = array();
				$u = array();
				$p = array();
				head_html("Очистка базы данных");
				print "<font class=title>Очистка базы данных</font>";
				$units = $netams->units();
				$policy = $netams->policy();
				for($i=0;$i<count($units);$i++)
				{
					$total[] = $units[$i]['db_oid'];
					$u[] = $units[$i]['db_oid'];
				}
				for($i=0;$i<count($policy);$i++)
				{
					$total[] = $policy[$i]['db_oid'];
					$p[] = $policy[$i]['db_oid'];
				}

				$where = "`oid` <> " . implode(" and `oid` <> ",$total);
				$sql_oids = "SELECT * FROM `oids` WHERE ".$where;
				$table->td("Таблица oids:|".db_query($sql_oids,"num")."|&nbsp;");

				$where = " `unit_oid` <> " . implode(" and `unit_oid` <> ",$u);
				$sql_raw_units = "SELECT * FROM `raw` WHERE ".$where;
				$table->td("Таблица raw (юниты):|".db_query($sql_raw_units,"num")."|&nbsp;");
				$where = " `policy_oid` <> " . implode(" and `policy_oid` <> ",$p);
				$sql_raw_policy = "SELECT * FROM `raw` WHERE  ".$where;
				$table->td("Таблица raw (политики):|".db_query($sql_raw_policy,"num")."|&nbsp;");

				$where = "`unit_oid` <> " . implode(" and `unit_oid` <> ",$u);
				$sql_summary_units = "SELECT * FROM `summary` WHERE ".$where;
				$table->td("Таблица summary (юниты):|".db_query($sql_summary_units,"num")."|&nbsp;");
				$where = "`policy_oid` <> " . implode(" and `policy_oid` <> ",$p);
				$sql_summary_policy = "SELECT * FROM `summary` WHERE ".$where;
				$table->td("Таблица summary (политики):|".db_query($sql_summary_policy,"num")."|&nbsp;");
                if (cfg('urls_monitor_enabled'))
                {
					$sql_monitor = "SELECT `time` FROM `monitor` WHERE `layer7` = '' ";
					$table->td("Таблица monitor:|".db_query($sql_monitor,"num")."|&nbsp;");
				}


				$table->c1(2);
				$table->c1();
				$table->show();

				foot_html();
			}
			else
			{
				$netams->config_save();
				$netams->reload();
                db_query("TRUNCATE `raw`");
                db_query("TRUNCATE `summary`");
                header("Location: ?mod=database");
			}
		break;

		default:
			$table = new Table;
			$table->title("Имя таблицы|Записей|Объем|Расход|Созданна|Обнавленна|Последняя оптимизация");
			head_html("Работа с базой данных");
			print "<font class=title>Информация о базе данных: ".cfg("dbname")."</font><br />";
			$sql = "SHOW TABLE STATUS";
			$row = db_query($sql,"multi");
			$all_size = 0;
			$all_count = 0;
			$all_ras = 0;
			for($i=0;$i<count($row);$i++)
			{
				$all_size = $all_size + $row[$i]['Data_length']+$row[$i]['Index_length'];
				$all_count = $all_count + $row[$i]['Rows'];
				$all_ras = $all_ras + $row[$i]['Data_free'];
				$size = data_size($row[$i]['Data_length']+$row[$i]['Index_length']);
				$size_free = data_size($row[$i]['Data_free']);
				$rashod = ($row[$i]['Data_free'] > 0) ? "<a href='?page=administrator&class=work_db&action=optimize_table&table_name=".$row[$i]['Name']."'>".$size_free."</a>" : "-";
				$table->td($row[$i]['Name']."|".$row[$i]['Rows']."|".$size."|".$rashod."|".$row[$i]['Create_time']."|".$row[$i]['Update_time']."|&nbsp;".$row[$i]['Check_time']);
			}
			$table->td("&nbsp;|<b>".$all_count."</b>|<b>".data_size($all_size)."</b>|<b>".data_size($all_ras)."</b>|&nbsp;|&nbsp;|&nbsp;");
			$table->show();
			print("<BR><font class=title>Временные промежутки данных</font>");
			$table->title("Таблица|Дата начальная|Дата конечная");
			if (cfg("urls_monitor_enabled") == true)
			{
				$be = db_query("SELECT `time` FROM `monitor` ORDER by `time` ASC LIMIT 0, 1");
				$en = db_query("SELECT `time` FROM `monitor` ORDER by `time` DESC LIMIT 0, 1");
				$table->td("monitor|".date("d.m.Y H:i", $be['time'])."|".date("d.m.Y H:i", $en['time']));
            }
			$be = db_query("SELECT `t_from` FROM `raw` ORDER by `t_from` ASC LIMIT 0, 1");
			$en = db_query("SELECT `t_from` FROM `raw` ORDER by `t_from` DESC LIMIT 0, 1");
			$table->td("raw|".date("d.m.Y H:i", $be['t_from'])."|".date("d.m.Y H:i", $en['t_from']));

			$be = db_query("SELECT `t_from` FROM `summary` ORDER by `t_from` ASC LIMIT 0, 1");
			$en = db_query("SELECT `t_from` FROM `summary` ORDER by `t_from` DESC LIMIT 0, 1");
			$table->td("summary|".date("d.m.Y H:i", $be['t_from'])."|".date("d.m.Y H:i", $en['t_from']));


			$table->show();
			print("<BR><font class=title>Резервные копии и ротация данных</font>");
			if (is_dir(cfg("backup_dir")) && file_exists(cfg("backup_dir")))
			{
				$dir = dir(cfg("backup_dir"));
			}
			foot_html();
		break;
	}
}

function backup_table_data($table, $datetime)
{
	$file_name = "rotate_".$table."_".time().".sql";
	$file = @fopen($cfg['backup_dir']."/".$file_name) or die("error on open file");
	fwrite($file, "INSERT INTO `".$table."` VALUES\n");
	$result = db_query("SELECT * FROM `".$table."` WHERE t_from < " . mktime(0,0,0,1, 1, $year + 1) . " AND t_from > " . mktime(0,0,0,1, 1, $year - 1)) or die("invalid query: ".mysql_error());
	$total = mysql_num_rows($result);
	$n = 0;
	while($row = mysql_fetch_row($result)) {
		$n ++;
		for($i=0;$i<$fields;$i++)
		{
			if ($is_num[$i])
				$row[$i] = isset($row[$i]) ? $row[$i] : "NULL";
			else
				$row[$i] = isset($row[$i]) ? "'" . mysql_escape_string($row[$i]) . "'" : "NULL";
		}
		fwrite($file, "(" . implode(", ", $row) . ")" . ($n == $total ? ";" : ",") . "\n");
	}
}

function total_backup($file_path, $bdate = 0, $edate = 0)
{
	$file = @fopen($file_path, "w+") or die("can`not open file: ".$file_path." to write");
	$tables_count = 0;
	$row_count = 0;
	$tables = db_query("SHOW TABLES","multi");
	$text = "";
	db_query("SET SQL_QUOTE_SHOW_CREATE = 1");
	for($i=0;$i<count($tables);$i++)
	{
		//print $i;
//		print_r($tables);
		$tables_count ++;
		$create_table_sql = db_query("SHOW CREATE TABLE `".$tables[$i][0]."`");
		$create_table_sql = preg_replace('/(default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP|DEFAULT CHARSET=\w+|character set \w+|collate \w+)/i', '/*!40101 \\1 */', $create_table_sql[1]);
		//print $create_table_sql."<br>";
		$text .= "DROP TABLE IF EXISTS `".$tables[$i][0]."`;\n".$create_table_sql.";\n\n";
		$colums = db_query("SHOW COLUMNS FROM `".$tables[$i][0]."`", "multi");
		for($n=0;$n<count($colums);$n++) $is_num[$n] = preg_match("/^(\w*int|year)/", $colums[$n][1]) ? 1 : 0;
		$num = db_query("SELECT * FROM `".$tables[$i][0]."`","num");
		if ($num > 0) $text .= "INSERT INTO `".$tables[$i][0]."` VALUES";
		$values = array();
		$where = "";

		if ($bdate > 0)
		{
			if ($tables[$i][0] == "raw" || $tables[$i][0] == "summary")
			{
				$where = "WHERE `t_from` < '".$date."' ";
			} else if ($tables[$i][0] == "monitor") {
				$where = "WHERE `time` < `".$date."`";
			}
		}
		$data = db_query("SELECT * FROM `".$tables[$i][0]."` ".$where , "multi");
		//print_r($data);
		for($k=0;$k<count($data);$k++)
		{
			$row_count ++;
			for($s=0;$s<count($colums);$s++)
			{
				if ($is_num[$s])
				{
					$values[$s] = (isset($data[$k][$colums[$s][0]])) ? $data[$k][$colums[$s][0]] : "NULL";
				}
				else
				{
					$values[$s] = (isset($data[$k][$colums[$s][0]])) ? "'".mysql_escape_string($data[$k][$colums[$s][0]])."'" : "NULL";
				}
			}
			$text .= ($k == $num || $k == 0) ? "" : ",";
			$text .=  "\n(".implode(",",$values).")";
		}
		if ($num>0)	$text .= ";\n\n";
	}
	print "Таблиц выгруженно: ".$tables_count." <br>Строк выгруженно: ".$row_count;
	fwrite($file, $text);
	fclose($file);
}






?>