<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

$modules_list[] = array("policy", "Модуль управления политиками", "0.1", "Egor N. Zuskin", "ice@it2k.ru", "", "");

$admin_menu[] = array(0, "Политики", "?mod=policy", "images/mini_policy.gif", "policy");
$admin_menu[] = array(1, "Default acct-policy", "?mod=policy&action=acct-policy");
$admin_menu[] = array(1, "Default fw-policy", "?mod=policy&action=fw-policy");


$policy_type_title['proto']         = "Протокол";
$policy_type_title['file']          = "Файл";
$policy_type_title['policy-or']     = "Частичное совпадение политек";
$policy_type_title['policy-and']    = "Полное совпадение политек";
$policy_type_title['layer7-detect'] = "Определение запрошенных страниц";


$policy_type = array("proto","file","policy-or","policy-and","layer7-detect");

$palicy_help['proto'] = "Текст помощи...";

function policy_init()
{
	global $netams, $policy_type_title, $policy_type, $palicy_help;

    $save = (isset($_GET['save']) &&  $_GET['save'] == "yes") ? true : false;
    $action = (isset($_GET['action'])) ? $_GET['action'] : "";
	$oid  = (isset($_GET['oid'])) ? $_GET['oid'] : "";

    $table = new Table();

	switch($action){

		case "acct-policy-add":
			if (isset($_GET['policy']) && $_GET['policy'] <> "")
			{
				$netams->policy_set_default_acct($_GET['policy']);
			}
			Header("Location: ?mod=policy&action=acct-policy");
		break;

		case "acct-policy-delete":
			if (isset($_GET['policy']) && $_GET['policy'] <> "")
			{
				$netams->policy_delete_default_acct($_GET['policy']);
			}
			Header("Location: ?mod=policy&action=acct-policy");
		break;

		case "acct-policy":
			if ($save)
			{
            	if (isset($_POST['policy']))
            	{
                	$netams->policy_set_default_acct($_POST['policy']);
            	}
            	Header("Location: ?mod=policy&action=acct-policy");
			}
			else
			{
				$pol = (isset($_GET['pol'])) ? $_GET['pol'] : ((intval(@$_GET['pol_empty']) == 1) ? array() : $netams->policy_get_default_acct());
				$pol_list = $netams->policy();
				$exists_pol = array();
				$lnk = "";
				$tmp_pol = "";
				$max = count($pol);

				if (isset($_GET['up']))
				{
					$id = array_search($_GET['up'] ,$pol);
					if ($id > 0)
					{
						$pol[$id] = $pol[$id-1];
						$pol[$id-1] = $_GET['up'];
					}
				}

				if (isset($_GET['down']))
				{
					$id = array_search($_GET['down'] ,$pol);
					if ($id < $max)
					{
						$pol[$id] = $pol[$id+1];
						$pol[$id+1] = $_GET['down'];
					}
				}

				head_html("Политики учета трафика по умолчанию");
				note("<font color=red>Внимание!</font><br>Добавление или удаление политики из списка, применятся на лету. А изменение позиции в списке политек, толко при нажатии кнопки \"Сохранить\".<br>"
					."Кнопка \"Сбросить\", сбрасывает изменения в позициях списка политек.");
				print "<font class=title>Политики учета трафика по умолчанию</font>";
				print "<form action='?mod=policy&action=acct-policy&save=yes' method='post'>";

				if ($max > 0)
				{
					$table->title("Номер|Название|Положение|Действие");
					for($i=0;$i<count($pol);$i++)
					{
						$lnk .= "pol[]=".$pol[$i]."&";
                    }
					for($i=0;$i<count($pol);$i++)
					{
						$tmp_pol .= $pol[$i] . " ";
						$nam = str_replace("!","",str_replace("%","",$pol[$i]));
						$exists_pol[] = $nam;
						if ($max == 1)
						{
							$arr = "-";
						}
						else if ($i == 0)
						{
							$arr = "<a href='?mod=policy&action=acct-policy&".$lnk."down=".$pol[$i]."'><img title='опустить' src='images/down.gif'></a>";
						}
						else if ($i == $max-1)
						{
							$arr = "<a href='?mod=policy&action=acct-policy&".$lnk."up=".$pol[$i]."'><img title='поднять' src='images/up.gif'></a>";
						}
						else
						{
							$arr = "<a href='?mod=policy&action=acct-policy&".$lnk."up=".$pol[$i]."'><img title='поднять' src='images/up.gif'></a><a href='?mod=policy&action=acct-policy&".$lnk."down=".$pol[$i]."'><img title='опустить' src='images/down.gif'></a>";
						}
						$img  = file_exists("images/proto/".$nam.".gif") ? "<img src='images/proto/".$nam.".gif'>&nbsp;" : "";
						$table->td(($i+1)."|".$img.$pol[$i]."|".$arr."|<a href='?mod=policy&action=acct-policy-delete&policy=".$pol[$i]."'><img title='Удалить' src='images/delete.gif'></a>");
					}
					$table->c1(1);
					$table->c1(3);
					$table->c1();
					$table->show();
				}
				else
				{
                	print "<br><br><font color=red>Нет политек учета трафика по умолчанию.</font><br><br>";
				}
				$table->title("Наименование|Действие");
				for($i=0;$i<count($pol_list);$i++)
				{
					if (array_search($pol_list[$i]['name'] ,$exists_pol) === false)
					{
						$img  = file_exists("images/proto/".$pol_list[$i]['name'].".gif") ? "<img src='images/proto/".$pol_list[$i]['name'].".gif'>&nbsp;" : "";
						$table->td($img.$pol_list[$i]['name']."|<img onmouseover=\"this.style.cursor='pointer';\" onclick=\"javascript:add_to_acct_policy('?mod=policy&action=acct-policy-add&policy=','".$pol_list[$i]['name']."');\" title='Добавить' src='images/add.gif'>");
					}
				}
				if ($table->gl_count > 1)
				{
					print "<br><font class=title>Доступные политики</font><br>";
					$table->c1();
					$table->show();
					print "<br>Добавлять: <select name=\"flag\"><option value=\"\">без флага</option><option value=\"%\">с флагом %</option><option value=\"!\">с флагом !</option><option value=\"!%\">с флагами !%</option></select>";
				}
				print "<input name=\"policy\" type=\"hidden\" value=\"".$tmp_pol."\">";
				print "<br><br>". back_btn()."&nbsp;".btn("Сбросить","?mod=policy&action=acct-policy")."&nbsp;<input type=\"submit\" value=\"Сохранить\">";
				print "</form>";
				foot_html();
			}
		break;

		case "fw-policy-add":
			if (isset($_GET['policy']) && $_GET['policy'] <> "")
			{
				$netams->policy_set_default_fw($_GET['policy']);
			}
			Header("Location: ?mod=policy&action=fw-policy");
		break;

		case "fw-policy-delete":
			if (isset($_GET['policy']) && $_GET['policy'] <> "")
			{
				$netams->policy_delete_default_fw($_GET['policy']);
			}
			Header("Location: ?mod=policy&action=fw-policy");
		break;

		case "fw-policy":
			if ($save)
			{
            	if (isset($_POST['policy']))
            	{
                	$netams->policy_set_default_fw($_POST['policy']);
            	}
            	Header("Location: ?mod=policy&action=fw-policy");
			}
			else
			{
				$pol = (isset($_GET['pol'])) ? $_GET['pol'] : ((intval(@$_GET['pol_empty']) == 1) ? array() : $netams->policy_get_default_fw());
				$pol_list = $netams->policy();
				$exists_pol = array();
				$lnk = "";
				$tmp_pol = "";
				$max = count($pol);

				if (isset($_GET['up']))
				{
					$id = array_search($_GET['up'] ,$pol);
					if ($id > 0)
					{
						$pol[$id] = $pol[$id-1];
						$pol[$id-1] = $_GET['up'];
					}
				}

				if (isset($_GET['down']))
				{
					$id = array_search($_GET['down'] ,$pol);
					if ($id < $max)
					{
						$pol[$id] = $pol[$id+1];
						$pol[$id+1] = $_GET['down'];
					}
				}

				head_html("Политики блокировки трафика по умолчанию");
				note("<font color=red>Внимание!</font><br>Добавление или удаление политики из списка, применятся на лету. А изменение позиции в списке политек, толко при нажатии кнопки \"Сохранить\".<br>"
					."Кнопка \"Сбросить\", сбрасывает изменения в позициях списка политек.");
				print "<font class=title>Политики блокировки трафика по умолчанию</font>";
				print "<form action='?mod=policy&action=fw-policy&save=yes' method='post'>";

				if ($max > 0)
				{
					$table->title("Номер|Название|Положение|Действие");
					for($i=0;$i<count($pol);$i++)
					{
						$lnk .= "pol[]=".$pol[$i]."&";
                    }
					for($i=0;$i<count($pol);$i++)
					{
						$tmp_pol .= $pol[$i] . " ";
						$nam = str_replace("!","",str_replace("%","",$pol[$i]));
						$exists_pol[] = $nam;
						if ($max == 1)
						{
							$arr = "-";
						}
						else if ($i == 0)
						{
							$arr = "<a href='?mod=policy&action=fw-policy&".$lnk."down=".$pol[$i]."'><img title='опустить' src='images/down.gif'></a>";
						}
						else if ($i == $max-1)
						{
							$arr = "<a href='?mod=policy&action=fw-policy&".$lnk."up=".$pol[$i]."'><img title='поднять' src='images/up.gif'></a>";
						}
						else
						{
							$arr = "<a href='?mod=policy&action=fw-policy&".$lnk."up=".$pol[$i]."'><img title='поднять' src='images/up.gif'></a><a href='?mod=policy&action=fw-policy&".$lnk."down=".$pol[$i]."'><img title='опустить' src='images/down.gif'></a>";
						}
						$img  = file_exists("images/proto/".$nam.".gif") ? "<img src='images/proto/".$nam.".gif'>&nbsp;" : "";
						$table->td(($i+1)."|".$img.$pol[$i]."|".$arr."|<a href='?mod=policy&action=fw-policy-delete&policy=".$pol[$i]."'><img title='Удалить' src='images/delete.gif'></a>");
					}
					$table->c1(1);
					$table->c1(3);
					$table->c1();
					$table->show();
				}
				else
				{
                	print "<br><br><font color=red>Нет политек блокировки трафика по умолчанию.</font><br><br>";
				}
				$table->title("Наименование|Действие");
				for($i=0;$i<count($pol_list);$i++)
				{
					if (array_search($pol_list[$i]['name'] ,$exists_pol) === false)
					{
						$img  = file_exists("images/proto/".$pol_list[$i]['name'].".gif") ? "<img src='images/proto/".$pol_list[$i]['name'].".gif'>&nbsp;" : "";
						$table->td($img.$pol_list[$i]['name']."|<img onmouseover=\"this.style.cursor='pointer';\" onclick=\"javascript:add_to_acct_policy('?mod=policy&action=fw-policy-add&policy=','".$pol_list[$i]['name']."');\" title='Добавить' src='images/add.gif'>");
					}
				}
				if ($table->gl_count > 1)
				{
					print "<br><font class=title>Доступные политики</font><br>";
					$table->c1();
					$table->show();
					print "<br>Добавлять: <select name=\"flag\"><option value=\"\">без флага</option><option value=\"%\">с флагом %</option><option value=\"!\">с флагом !</option><option value=\"!%\">с флагами !%</option></select>";
				}
				print "<input name=\"policy\" type=\"hidden\" value=\"".$tmp_pol."\">";
				print "<br><br>". back_btn()."&nbsp;".btn("Сбросить","?mod=policy&action=fw-policy")."&nbsp;<input type=\"submit\" value=\"Сохранить\">";
				print "</form>";
				foot_html();
			}
		break;

		case "delete_policy":
			if ($oid <> "")
			{
            	$netams->policy_delete($oid);
            }
			Header("Location: ?mod=policy");
		break;

		case "edit_policy":
			$type = (isset($_GET['type'])) ? intval(($_GET['type'])) : -1;
        	$param = "";
        	$policy = $netams->policy();
        	if ($save)
        	{
        		$name = (isset($_POST['name'])) ? trim($_POST['name']) : "";
            	switch($type)
            	{
            		case 0:
            			if (isset($_POST['proto']))
            			{
            				$param = "target proto " . $_POST['proto'];
            				if (@$_POST['port'] <> '')
            					$param .= " port " . $_POST['port'];
            			}
            		break;

            		case 1:
            			if (isset($_POST['file_name']))
            			{
            				$param = "target file " . $_POST['file_name'];
            			}
            		break;

					case 2:
					case 3:
            			if (isset($_POST['temp_pol']))
            			{
            				$param = "target ".$policy_type[$type]." " . $_POST['temp_pol'];
            			}
					break;

                    case 4:
                    	$param = "target layer7-detect";
                    break;

            		default:
            			Header("Location: ?mod=policy");
            		break;
            	}
            	if ($name && $param)
            	{
					for($i=0;$i<count($policy);$i++)
					{
						if ($name == $policy[$i]['name'] && $oid <> $policy[$i]['oid'])
						{
							error_html("Политика: ".$name." уже существует в списке политек");
							die();
						}
					}
                    $netams->policy_edit("name " . $name ." " . $param, $oid);
	          	}
            	Header("Location: ?mod=policy");
        	}
        	else
        	{
        		$page_title = ($oid == "") ? "Добавление новой политики" : "Изменение политики";

        		$name = (isset($_GET['name'])) ? $_GET['name'] : "";
                $proto = "tcp";

        		head_html($page_title);
        		print "<font class=title>".$page_title."</font><br><br>";
        		head_note();
        		if ($type < 0)
        		{
        			print "Выберите тип политики: <select size=\"1\" onchange=\"location='?mod=policy&action=edit_policy&type='+this.options[this.selectedIndex].value\" name=\"type\"><option value=\"-1\">Не выбранно ...</option>";
        			for($i=0;$i<count($policy_type);$i++)
        			{
        				print "<option value=\"".$i."\">".$policy_type_title[$policy_type[$i]]."</option>";
        			}
        			print "</select><br><br>".back_btn();
        		}
        		else
        		{
                    if (isset($palicy_help[$policy_type[$type]]))
                    {
                    	print $palicy_help[$policy_type[$type]];
                    	foot_note();
                    	head_note();
                    }

					$cur_policy = array();

					if ($oid <> "")
					{
						for($i=0;$i<count($policy);$i++)
						{
							if ($oid == $policy[$i]['oid'])
							{
								$cur_policy = $policy[$i];
								break;
							}
						}
						$name = $cur_policy['name'];
						$tmp = explode(" ", $cur_policy['param']);
					}

	        		print "<form action='?mod=policy&action=edit_policy&save=yes&type=".$type."&oid=".$oid."' method=post>\n";
	        		print "<input name=\"policy_type\" type=\"hidden\" value=\"".$type."\">";
	        		print "<input name=\"param\" type=\"hidden\" value=\"\">";

	        		$table->td("Тип:|<b>".$policy_type_title[$policy_type[$type]]."</b>");
	        		$table->td("Наименование:|<input size=50 name=\"name\" type=\"text\" value=\"".$name."\">");
	        		switch($type)
	        		{
	        			case 0:
	        				if ($oid)
	        				{
	        					$proto = $tmp[2];
        						$port = ($proto == "tcp" || $proto == "udp") ? str_replace("target: proto " . $proto . " port ", "", $cur_policy['param']) : "";
	        				}
	        				else
	        				{
	        					$proto = "tcp";
	        					$port  = "0";
	        				}
		        			$table->td("Протакол:|<input name=\"proto\" type=\"text\" value=\"".$proto."\">");
		        			$table->td("Порт(ы):|<input size=50 name=\"port\" type=\"text\" value=\"".$port."\">");
	        			break;
	        			case 1:
	        				$file = ($oid) ? str_replace("target: file ", "", $cur_policy['param']) : "";
		        			$table->td("Путь файла:|<input size=50 name=\"file_name\" type=\"text\" value=\"".$file."\">");
	        			break;
	        			case 2:
	        			case 3:
       			            $pol_list = isset($_GET['pol_list']) ? $_GET['pol_list'] : (($oid) ? explode(" ", str_replace("target: ".$policy_type[$type]." ", "", $cur_policy['param'])) : array());
       			            $cont = "";
       			            $lnk  = "";
       			            if (count($pol_list) > 0)
       			            {

					            for($i=0;$i<count($pol_list);$i++)
						        	$lnk .= "pol_list[]=".$pol_list[$i]."&";

       			            	$cont .= "<b>Совпадение политик:</b><br><table>";
       			            	$tmp_pol = "";
					            for($i=0;$i<count($pol_list);$i++)
						        {
								 	$tmp_pol .= $pol_list[$i]." ";
	                            	$cont .= "<tr><td>" . $pol_list[$i] . "&nbsp;&nbsp;</td><td><a href='?mod=policy&action=edit_policy&".str_replace("pol_list[]=".$pol_list[$i]."&","",$lnk)."&name=".$name."&oid=".$oid."&type=".$type."'><img title='Удалить' src='images/delete.gif'></a></td></tr>";
	                            }
  	       			            print "<input name=\"temp_pol\" type=\"hidden\" value=\"".trim($tmp_pol)."\">";
								$cont .= "</table><hr>";
	                        }
   			            	$cont .= "<b>Доступные политики:</b><br><table>";
				            for($i=0;$i<count($policy);$i++)
					        {
                            	if (array_search($policy[$i]['name'],$pol_list) === false)
                            	{
                            		$cont .= "<tr><td>".$policy[$i]['name'] . "&nbsp;&nbsp;</td><td><a href='?mod=policy&action=edit_policy&".$lnk."pol_list[]=".$policy[$i]['name']."&name=".$name."&oid=".$oid."&type=".$type."'><img title='Добавить' src='images/add.gif'></a></td></tr>";
                            	}
                            }
                            $cont .= "</table>";
		        			$table->td("Политики:|".$cont);
	        			break;

	        		}
	        		$table->tr(back_btn()."&nbsp;<input type=\"submit\" value=\"Сохранить\">" . (($oid) ? "&nbsp;". del_btn("Удалить","?mod=policy&action=delete_policy&oid=".$oid,'Вы действительно хотите удалить политику '.$name.'?') : ""));
	        		$table->show();
	        		print "</form>";
        		}
        		foot_note();
        		foot_html();
        	}
		break;
		default:
			$table->title("Номер|Наименование|OID|DB|Тип|Параметры|Действие");
			head_html("Список политек");

			print "<font class=title>Список политек</font><br>";
			print "<br>". btn("Добавить политику","?mod=policy&action=edit_policy")."<br><br>";
            $policy = $netams->policy();
            for($i=0;$i<count($policy);$i++)
            {
            	$tmp = explode(" ",$policy[$i]['param']);
            	$img  = file_exists("images/proto/".$policy[$i]['name'].".gif") ? "<img src='images/proto/".$policy[$i]['name'].".gif'>&nbsp;" : "";
            	$act = btn("Изменить","?mod=policy&action=edit_policy&oid=".$policy[$i]['oid']."&type=".array_search($tmp[1],$policy_type)."")."&nbsp;".del_btn("Удалить","?mod=policy&action=delete_policy&oid=".$policy[$i]['oid'],'Вы действительно хотите удалить политику '.$policy[$i]['name'].'?');
            	$param = trim(str_replace("target: ".$tmp[1],"",$policy[$i]['param']));
            	$table->td(($i+1)."|".$img.$policy[$i]['name']."|".$policy[$i]['oid']."|".$policy[$i]['db_oid']."|".$policy_type_title[$tmp[1]]."|".$param."&nbsp;|".$act);
            }
            $table->c1();
            $table->c1(1);
            $table->show();
			foot_html();
		break;
	}
}

?>