<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

$admin_menu[] = array(0, "Юниты", "?mod=units", "images/mini_user.gif", "units");
$admin_menu[] = array(1, "Добавить юнита", "?mod=units&action=edit_unit", "images/add.gif", "units");
$modules_list[] = array("units", "Модуль управления пользовательми", "0.1", "Egor N. Zuskin", "ice@it2k.ru", "", "");

function units_init($action, $oid)
{
	global $netams, $units_list;

	$oid  = _GET("oid");
	$type = _GET("type");

	switch($action){

		case "order_acct-policy":
			$pol = _GET("acct_pol");
			if ($pol <> "")
			{
				$max = count($pol);
				if (isset($_GET['up']))
				{
					$id = array_search($_GET['up'] ,$pol);
					if ($id > 0)
					{
						$pol[$id] = $pol[$id-1];
						$pol[$id-1] = $_GET['up'];
					}
				}

				if (isset($_GET['down']))
				{
					$id = array_search($_GET['down'] ,$pol);
					if ($id < $max)
					{
						$pol[$id] = $pol[$id+1];
						$pol[$id+1] = $_GET['down'];
					}
				}
				$param = implode(" ",$pol);
				$netams->unit_edit($type,$oid,"acct-policy ".$param);
			}
			Header("Location: " . $_SERVER['HTTP_REFERER']);
		break;

		case "monitor":
          if ($oid <> '')
          {
          	if (@$_GET['enabled'] == 'true')
          	{
          		$netams->monitor_add($oid);
          	}
          	if (@$_GET['enabled'] == 'false')
          	{
          		$netams->monitor_delete($oid);
          	}
          }
          Header("Location: " . $_SERVER['HTTP_REFERER']);
		break;

		case "delete_unit_from_group":
			$group_name = _GET("group_name");
			if ($type <> "" && $oid <> "" && $group_name <> "")
			{
				$netams->unit_edit($type, $oid, "no parent ".$group_name);
			}
			Header("Location: ?mod=units&action=edit_unit&oid=".$oid."&type=".$type);
		break;

		case "add_unit_to_group":
			$group_name = _POST("group_name");
			if ($type <> "" && $oid <> "" && $group_name <> "")
				$netams->unit_edit($type, $oid, "parent ".$group_name);
			Header("Location: ?mod=units&action=edit_unit&oid=".$oid."&type=".$type);
		break;

		case "delete_acct_policy_from_unit":
			$policy_name = _GET("policy_name");
			$netams->unit_edit($type, $oid, "no acct-policy ".$policy_name);
			Header("Location: ?mod=units&action=edit_unit&oid=".$oid."&type=".$type);
		break;

		case "add_acct_policy_to_unit":
			$policy = _POST("policy");
			$flag = _POST("flag");
			$netams->unit_edit($type, $oid, "acct-policy ".$flag.$policy);
			Header("Location: ?mod=units&action=edit_unit&oid=".$oid."&type=".$type);
		break;

		case "delete_fw_policy_from_unit":
			$policy_name = _GET("policy_name");
			$netams->unit_edit($type, $oid, "no fw-policy ".$policy_name);
			Header("Location: ?mod=units&action=edit_unit&oid=".$oid."&type=".$type);
		break;

		case "add_fw_policy_to_unit":
			$policy = _POST("policy");
			$netams->unit_edit($type, $oid, "fw-policy ".$policy);
			Header("Location: ?mod=units&action=edit_unit&oid=".$oid."&type=".$type);
		break;

		case "save_unit":
			$type  = _GET("type");
            $name  = _POST("name");
            $email = _POST("email");
            $ip    = _POST("ip");
            $group = _POST("group");

			$param = (($name) ? " name ".$name : "") . (($email) ? " email ".$email : "") . (($ip) ? " parameters ip ".$ip : "")
					 .(($group) ? " parent " .$group  : "");
			$netams->unit_edit($type, $oid, $param);
				Header("Location: ?mod=units");
		break;

		case "edit_unit":
			edit_unit_form($oid, $type);
		break;

		case "delete_unit":
			if ($type <> "" && $oid <> "")
			{
				$netams->unit_delete($type, $oid);
			}
			Header("Location: ?mod=units");
		break;

		default:
			global $units_array;

            $units_list = $netams->units();

			if ($oid)
			{
				$unit = $units_list[unit_id_by("oid", $oid)];
				if ($unit['type'] == "group")
				{
					$parent = $unit['name'];
				}
				else
				{
					Header("Location: ?mod=units&action=edit_unit&oid=".$oid."&type=".$unit['type']);
					die();
				}
			}
			else
			{
				$parent = "";
			}
            $monitor_enabled = $netams->monitor_enabled();
            if ($monitor_enabled)
            {
            	$monitor_units = $netams->monitor_units();
            }
			$table = new Table;
			$table->title("Номер|Тип|OID|DB|Имя|".($monitor_enabled ? "Монитор|" : "")."NLP|Родитель|Почта|Параметры|Действие");
            $count = 0;
			for($i=0;$i<count($units_array);$i++)
			{
				$items = units_parent($units_array[$i],$parent);
				if (count($items) > 0)
				{
					$arr = array_keys($items);
					for($n=0;$n<count($arr);$n++)
					{
						$count ++;
						$item = $items[$arr[$n]];
						if ($monitor_enabled)
						{
							if (($item['type'] == "user" || $item['type'] == "host"))
							{
		                        $mon = (array_search($item['oid'], $monitor_units) !== false) ? "<a href='?mod=units&action=monitor&enabled=false&oid=".$item['oid']."'>Выключить</a>|" : "<a href='?mod=units&action=monitor&enabled=true&oid=".$item['oid']."'>Включить</a>|";

		                  	}
		                  	else
		                  	{
		                  		$mon = "&nbsp;|";
		              		}
	                    }
	                    else
	                    {
	                    	$mon = "";
						}
						$param = ($units_array[$i] <> "group") ? $item['param'] : " ... ";
						$act = btn("Изменить","?mod=units&action=edit_unit&oid=".$item['oid']."&type=".$item['type'])."&nbsp;".del_btn("Удалить","?mod=units&action=delete_unit&oid=".$item['oid']."&type=".$item['type']);
						$table->td( ($count)."|<img src='images/mini_".$units_array[$i].".gif'>&nbsp;".$units_array[$i]."|".$item['oid']."|".$item['db_oid']."|".$item['name']."|".$mon.$item['nlp']."&nbsp;|&nbsp;".$item['parent']."|&nbsp;".$item['email']."|&nbsp;".$param . "|".$act);
					}
				}
			}
			head_html("Управление юнитами");
			print "<font class=title>Список Юнитов</font><BR><br>";
			print btn("Добавить юнит","?mod=units&action=edit_unit")."<br><br>";
			$table->c1(1);
			$table->c1();
			$table->show();
			foot_html();
		break;
	}
}

//function edit_unit_form($new, $oid = "", $inf = "", $policy = "")
function edit_unit_form($oid = "", $type = "")
{
	global $netams, $units_array, $units_array_title;

	$title = ($oid) ? "Изменение юнита" : "Добавление нового юнита";
	head_html($title);
	if ($type == "")
	{
		head_note($title);
		print "Выберити тип юнита: <select name=\"type\" onchange=\"location='?mod=units&action=edit_unit&type='+this.options[this.selectedIndex].value\"><option value=\"\">Не выбранно ...</option>\n";
        for($i=0;$i<count($units_array);$i++)
        {
        	print "<option value=\"".$units_array[$i]."\">".$units_array_title[$i]."</option>";
        }
        print "</select><br><br>".back_btn();
		foot_note();
	}
	else
	{
		$table = new Table;
		$inf = get_element_by_attr($netams->units($type), "oid", $oid);
    	head_note($title);
    	$name  = ($oid) ? $inf['name']  : $type;
    	$email = ($oid) ? $inf['email'] : "";
        $ip    = ($oid) ? $inf['param'] : "0.0.0.0";
    	$table->td("Тип:|<b>".$units_array_title[array_search($type, $units_array)]."</b>");
    	$table->td("Наименование:|<input size=30 type=\"text\" name=\"name\" value=\"".$name."\">");
    	$table->td("E-mail ответственного за юнит:|<input size=30 type=\"text\" name=\"email\" value=\"".$email."\">");
//    	$table->td("Коментарий:|<input size=50 type=\"text\" name=\"comment\" value=\"\">");
    	if ($type <> "group")
    	{
    		$table->td((($type == "net") ? "IP адрес / маска" : "IP адрес").":|<input type=\"text\" name=\"ip\" value=\"".$ip."\">");
    	}
    	if (!$oid)
    	{
			$gr_list = array();
			$source_gr = $netams->units("group");
			$tmp  = "<select name=\"group\"><option value=\"\">Нет</option>";
			for($i=0;$i<count($source_gr);$i++)
				$tmp .= "<option value=\"".$source_gr[$i]['name']."\">".$source_gr[$i]['name']."</option>";
    		$tmp .= "</select>";
    		$table->td("Состоит в группе:|".$tmp."&nbsp;</from>");
    	}
    	else
    	{                                                                                                                                                                                   //document.forms[1]
			$add_form = "<form name=\"group_form\" action=\"?mod=units&action=add_unit_to_group&oid=".$inf['oid']."&type=".$inf['type']."\" method=\"POST\"><input onclick='javascript:document.group_form.submit();' type=\"button\" value=\"Добавить в группу\">&nbsp;&nbsp;<select name='group_name'>";
			$gr = array();
			$gr_list = array();
			$source_gr = $netams->units("group");
			$tmp2 = "";
			$tmp = explode(" ",$inf['parent']);
			for($i=0;$i<count($tmp);$i++)
				if ($tmp[$i] <> "")
				{
					$gr[] = $tmp[$i];
					$tmp2 .= "<a href='?mod=units&action=delete_unit_from_group&group_name=".$tmp[$i]."&oid=".$inf['oid']."&type=".$inf['type']."'><img src='images/delete.gif'></a> ".$tmp[$i]."<BR>";
				}
			for($i=0;$i<count($source_gr);$i++) $gr_list[$i] = $source_gr[$i]['name'];
			if ($type == "group")
			{
				$gr[] = $name;
			}
			$out = array_diff($gr_list, $gr);
			$tmp = array_keys($out);
			for($i=0;$i<count($out);$i++) $add_form .= "<option vlaue='".$out[$tmp[$i]]."'>".$out[$tmp[$i]]."</option>";

			$add_form .= "</select></form><BR><BR>";
			if (count($tmp) == 0) $add_form = "";

            $table->td("Состоит в группах:|</form>".$add_form.$tmp2."&nbsp;");
    	}
    	if ($oid)
    	{
	        $acct = "";
	        $fw   = "";

	        $source_pol = $netams->policy();
	        $unit_pol   = $netams->unit_policy($oid);

	    	$def_act = $netams->policy_get_default_acct();
	    	$def_act_noflag = array();

			// ACCT-POLICY
	        if (count($def_act) > 0)
	        {
	        	$def_act_noflag = explode(" ",trim(str_replace("!","",str_replace("%","",implode(" ",$def_act)))));
	        	$acct .= "<a title='".implode(" ",$def_act)."' href='?mod=policy&action=acct-policy'><font color=red>[Назначины политики по умолчанию]</font></a><br><br>";
	        }
	        $tmp_pol  = array();
	        $tmp_flag = array();
	        for($i=0;$i<count($unit_pol['acct']);$i++)
	        	if (array_search($unit_pol['acct'][$i]['name'], $def_act_noflag) === false)
	        	{
	        		$tmp_pol[]   = $unit_pol['acct'][$i]['name'];
	        		$tmp_flag[]  = $unit_pol['acct'][$i]['flag'];
	       		}
			$count = 0;
            $acct_pol_form = "<form name='acct_policy_form' action='?mod=units&action=add_acct_policy_to_unit&oid=".$inf['oid']."&type=".$inf['type']."' method=POST><select name=flag><option value=''>без флага</option><option value='!'>!</option><option value='%'>%</option><option value='!%'>!%</option></select>&nbsp;<select name=policy>";
	        for($i=0;$i<count($source_pol);$i++)
	        {
	        	if ((array_search($source_pol[$i]['name'], $def_act_noflag) === false) && (array_search($source_pol[$i]['name'], $tmp_pol) === false))
	        	{
	        		$count ++;
                   	$acct_pol_form .= "<option vlaue='".$source_pol[$i]['name']."'>".$source_pol[$i]['name']."</option>";
	        	}
			}
			$acct_pol_form .= "</select>&nbsp;<input onclick='javascript:document.acct_policy_form.submit();' type=\"button\" value=\"Добавить политику\"></form><BR><BR>";
			if ($count > 0)
				$acct .= $acct_pol_form;

			$max = count($tmp_pol);

            if ($max > 0)
            {
            	$lnk = "";
            	$tab = new Table();
				for($i=0;$i<$max;$i++)
				{
					$lnk .= "acct_pol[]=".$tmp_flag[$i].$tmp_pol[$i]."&";
				}
            	for($i=0;$i<$max;$i++)
            	{
					if ($max == 1)
					{
						$arr = "-";
					}
					else if ($i == 0)
					{
						$arr = "<a href='?mod=units&action=order_acct-policy&oid=".$oid."&type=".$type."&".$lnk."down=".$tmp_flag[$i].$tmp_pol[$i]."'><img title='опустить' src='images/down.gif'></a>";
					}
					else if ($i == $max-1)
					{
						$arr = "<a href='?mod=units&action=order_acct-policy&oid=".$oid."&type=".$type."&".$lnk."up=".$tmp_flag[$i].$tmp_pol[$i]."'><img title='поднять' src='images/up.gif'></a>";
					}
					else
					{
						$arr = "<a href='?mod=units&action=order_acct-policy&oid=".$oid."&type=".$type."&".$lnk."up=".$tmp_flag[$i].$tmp_pol[$i]."'><img title='поднять' src='images/up.gif'></a><a href='?mod=unit&action=order_acct-policy&oid=".$oid."&type=".$type."&".$lnk."down=".$tmp_flag[$i].$tmp_pol[$i]."'><img title='опустить' src='images/down.gif'></a>";
					}
					$img  = file_exists("images/proto/".$tmp_pol[$i].".gif") ? "<img src='images/proto/".$tmp_pol[$i].".gif'>&nbsp;" : "";

            		$tab->td(($i+1)."|".$img.$tmp_flag[$i].$tmp_pol[$i]."|".$arr."|<a href='?mod=units&action=delete_acct_policy_from_unit&policy_name=".$tmp_flag[$i].$tmp_pol[$i]."&oid=".$oid."&type=".$type."'><img src='images/delete.gif'></a>");
                }
                $tab->c1(1);
                $tab->c1(4);
                $tab->c1(3);
	            $acct .= $tab->show(1);
            }

    	    $table->td("Политики подсчета трафика:|".$acct."&nbsp;");
    	    // END OF ACCT-POLICY

			// FW-POLICY
			$def_fw  = $netams->policy_get_default_fw();

	        if (count($def_fw) > 0)
	        {
	        	$fw .= "<a title='".implode(" ",$def_fw)."' href='?mod=policy&action=acct-policy'><font color=red>[Назначины политики по умолчанию]</font></a><br><br>";
	        }

	        $tmp_pol  = array();
	        $tmp_flag = array();

	        for($i=0;$i<count($unit_pol['fw']);$i++)
	        	if (array_search($unit_pol['fw'][$i]['name'], $def_fw) === false)
	        	{
	        		$tmp_pol[]   = $unit_pol['fw'][$i]['name'];
	       		}
			$count = 0;
            $fw_pol_form = "<form name='fw_policy_form' action='?mod=units&action=add_fw_policy_to_unit&oid=".$inf['oid']."&type=".$inf['type']."' method=POST><select name=policy>";
	        for($i=0;$i<count($source_pol);$i++)
	        {
	        	if ((array_search($source_pol[$i]['name'], $def_fw) === false) && (array_search($source_pol[$i]['name'], $tmp_pol) === false))
	        	{
	        		$count ++;
                   	$fw_pol_form .= "<option vlaue='".$source_pol[$i]['name']."'>".$source_pol[$i]['name']."</option>";
	        	}
			}
			$fw_pol_form .= "</select>&nbsp;<input onclick='javascript:document.fw_policy_form.submit();' type=\"button\" value=\"Добавить политику\"></form><BR><BR>";
			if ($count > 0)
				$fw .= $fw_pol_form;

			$max = count($tmp_pol);

            if ($max > 0)
            {
            	$lnk = "";
            	$tab = new Table();
				for($i=0;$i<$max;$i++)
				{
					$lnk .= "fw_pol[]=".$tmp_pol[$i]."&";
				}
            	for($i=0;$i<$max;$i++)
            	{
					$img  = file_exists("images/proto/".$tmp_pol[$i].".gif") ? "<img src='images/proto/".$tmp_pol[$i].".gif'>&nbsp;" : "";
            		$tab->td(($i+1)."|".$img.$tmp_pol[$i]."|<a href='?mod=units&action=delete_fw_policy_from_unit&policy_name=".$tmp_pol[$i]."&oid=".$oid."&type=".$type."'><img src='images/delete.gif'></a>");
                }
                $tab->c1(1);
                $tab->c1(3);
	            $fw .= $tab->show(1);

            }


	        $table->td("Политики фильтрации трафика:|".$fw."&nbsp;");
		}
		print "<form name=\"main_form\" action=\"?mod=units&action=save_unit&oid=".$oid."&type=".$type."\" method=\"POST\">";
    	$table->show();
    	print "<br>".back_btn()."&nbsp;<input nclick='javascript:document.main_form.submit();' type=\"button\" value=\"Сохранить\">";
    	if ($oid)
    	{
    		print "&nbsp;".del_btn("Удалить","?mod=units&action=delete_unit&oid=".$oid."&type=".$oid);

            $monitor_enabled = $netams->monitor_enabled();
            if ($monitor_enabled)
            {
            	$monitor_units = $netams->monitor_units();
            	if ($type == "user" || $type == "host")
            	{
            		print "&nbsp;" . ((array_search($oid,$monitor_units) !== false) ? btn("Выключить монитор","?mod=units&action=monitor&enabled=false&oid=".$oid) : btn("Включить монитор","?mod=units&action=monitor&enabled=false&oid=".$oid));
            	}
            }


    	}
    	foot_note();
	}
	foot_html();
}

?>