<?php
/*
 This program is free software. You can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License.
*/

if (eregi("config.php",$_SERVER['PHP_SELF'])) {
    Header("Location: /");
    die();
}

header("Content-Type: text/html; charset=utf-8");

$i=-1;

# Путь расположения NetAMS-front относительно url
define('PATH','/netams-front/');

# Включен ли трай клиент
$cfg['netams_client_enabled']     = true;
# Отдовать статистику по политике
$cfg['netams_client_policy']      = "ip";
# Время обновления статистики клиентом
$cfg['netams_client_update_time'] = 3 * 60;

# Директория для резервного копирования
$cfg['backup_dir'] = "./backup";
# Ип адреса админов разделенные пробелом
$cfg['admins_ip']  = "127.0.0.1 192.168.0.1";

# До скольки знаков округлять трафик
$cfg['round_traffic_to'] = 2;
# Заменять символы "space_separator" на пробелы или нет
$cfg['replace_space_separator'] = true;
# Читай выше! Какой символ считать за пробел
$cfg['space_separator'] = "_";

# Секция для переименования политек
$proto_title['ip']        = "Интернет";
$proto_title['local']     = "Локальный";
$proto_title['icq']       = "Аська";
$proto_title['mail']      = "Почта";
$proto_title['www']       = "Веб";
$proto_title['other_tcp'] = "Иной трафик (tcp)";
$proto_title['other_udp'] = "Иной трафик (udp)";
$proto_title['other']     = "Иной трафик";
$proto_title['ftp']       = "FTP";
$proto_title['rdesktop']  = "Терминал клиент";
$proto_title['ping']      = "Ping";
$proto_title['ssh']       = "Ssh";
$proto_title['vnc']       = "Vnc";
$proto_title['samba']     = "Сетевое окружение";

$i++;
# Имя сервера
$data_base[$i]['name'] = "Основной сервер";
# Хост базы данных mysql
$data_base[$i]['dbhost'] = "127.0.0.1";
# Имя пользователя для подключения к базе данных mysql
$data_base[$i]['dbuname'] = "netams";
# Пароль пользователя для подключения к базе данных mysql
$data_base[$i]['dbpass'] = "netams";
# Имя базы данных mysql
$data_base[$i]['dbname'] = "netams";
# Тип клиента, может быть "telnet" или "ctl"
# ctl    - клиент "netamsctl" из пакета netams
# telnet - telnet сдиент средствами php
$data_base[$i]['netamsclient'] = "telnet";
# Строка для запуска netamsctl параметр -f указывает где лежит конфиг netamsctl
# Если не указанн исчет его по стандартным путям читай "man netamsctl"
$data_base[$i]['netamsctl']  = "/usr/local/sbin/netamsctl -f /etc/netams/.netamsctl.rc";
# Хост netams сервера
$data_base[$i]['netamshost'] = "127.0.0.1";
# Порт netams сервера
$data_base[$i]['netamsport'] = 20001;
# Пользователь netams
$data_base[$i]['netamsuser'] = "admin";
# Пароль
$data_base[$i]['netamspass'] = "aaa";
# Таймаут подключения
$data_base[$i]['netamstimeout'] = 10;
# Таймаут выполнения команд
$data_base[$i]['netamscommandtimeout'] = 125000;
# Список ГЛАВНЫХ политек, разделяются пробелом
# одна из таких политек ip (смотри в конфиг --> policy name ip target proto ip)
$data_base[$i]['traffic_list'] = "ip local";
# сумматор политек например "ip + local" - каждый элемент дожен быть отделен пробелом
$data_base[$i]['traffic_sum_calc'] = "";
# какие протоколы нужно скрывать из "Статистике по протоколам"
# например "url" - если вы собираете статистику layer7-detect см. документацию к NetAMS
$data_base[$i]['proto_hide_list'] = "urls";
# какие протаколы отабражаются в "Статистика по группе"
$data_base[$i]['group_show_policy'] = "ip local www mail";
#$data_base[$i]['user_grouping_by_ip'] = false;
# Ип адреса пользователей которые могут смотреть статистику по всем юнитам
$data_base[$i]['adv_users'] = $cfg['admins_ip'] . "127.0.0.1 192.168.0.1 192.168.0.2";
# Включен режим layer7-detect см. документацию к NetAMS
$data_base[$i]['urls_monitor_enabled'] = false;
# Включен режим квот
$data_base[$i]['quota_enabled'] = false;

?>
